package apachepoi;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.apache.poi.EncryptedDocumentException;
import org.apache.poi.openxml4j.exceptions.InvalidFormatException;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DataFormatter;
import org.apache.poi.ss.usermodel.FormulaEvaluator;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.usermodel.WorkbookFactory;
import org.apache.poi.ss.util.AreaReference;
import org.apache.poi.ss.util.CellReference;


public class TestExcelDisplayZero {

	private static final String FILE_NAME = "/home/ssaleh/Desktop/Workbook1.xlsx";
	private static final String SHEET_NAME = "Sheet1";
	private static final String RANGE = "A1:A3";
	public static void main(String args[]) {
		try {
			FileInputStream excelFile = new FileInputStream(new File(FILE_NAME));
			Workbook workbook = null;
			workbook = WorkbookFactory.create(excelFile);
			Sheet sheet = workbook.getSheet(SHEET_NAME);
			System.out.println("DisplayZero : " + sheet.isDisplayZeros());
			AreaReference aref = new AreaReference("'" + SHEET_NAME +"'!" +RANGE, workbook.getSpreadsheetVersion());
			CellReference[] crefs = aref.getAllReferencedCells();
		    for (int i=0; i<crefs.length; i++) {
		    	String cellValue = "";
		    	Sheet s = workbook.getSheet(crefs[i].getSheetName());
		    	if (s == null){
		    		continue;
		    	}
		        Row r = s.getRow(crefs[i].getRow());
		        if (r == null){
		        	continue;
		        }
		        Cell c = r.getCell(crefs[i].getCol());
		        if (c != null){
		        	DataFormatter objDefaultFormat = new DataFormatter();	
	        		FormulaEvaluator evaluator = workbook.getCreationHelper().createFormulaEvaluator();
	        		evaluator.evaluate(c);
		        	String val = objDefaultFormat.formatCellValue(c,evaluator);
		        	System.out.println("Cell Value [evaluator] :" + val);
		        	switch (c.getCellTypeEnum()) {
				    case STRING:
				        cellValue = c.getStringCellValue();
				        break;
				    case BOOLEAN:
				        cellValue = Boolean.toString(c.getBooleanCellValue());
				        break;
				    case NUMERIC:
				        cellValue = Integer.toString((int) c.getNumericCellValue());
				        break;
					default:
						break;
			        }
		        	System.out.println("Cell value [normal] :" + cellValue);

		        }
		    }
		    
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (EncryptedDocumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvalidFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
